# Linux Kernel Module Cheat
The perfect emulation setup to study and develop the <<linux-kernel>> v5.9.2, kernel modules, <<qemu-buildroot-setup,QEMU>>, <<gem5-buildroot-setup,gem5>> and x86_64, ARMv7 and ARMv8 <<userland-assembly,userland>> and <<baremetal-setup,baremetal>> assembly, <<c,ANSI C>>, <<cpp,C++>> and <<posix,POSIX>>. <<gdb>> and <<kgdb>> just work. Powered by <<about-the-qemu-buildroot-setup,Buildroot>> and <<about-the-baremetal-setup,crosstool-NG>>. Highly automated. Thoroughly documented. Automated <<test-this-repo,tests>>.

### 27.10. userland/libs directory

Tests under userland/libs require certain optional libraries to be installed on the target, and are not built or tested by default, you must enable them with either:

    --package <package>
    --package-all

See for example BLAS. Since it is located under `userland/libs/openblas`, it will only build with either:

    ./build-userland --package openblas
    ./build-userland --package-all

As an exception, if you first `cd` directly into one of the directories and do a native host build, e.g.:

    sudo apt install libeigen3-dev
    cd userland/libs/eigen
    ./build

then that library will be automatically enabled.

See also:

- C++ third-party libraries